您的位置:首页 > 其它

LeetCode 292:Nim Game(尼姆游戏)

2017-05-26 15:51 267 查看
You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.


思路:

这其实是一个脑筋急转弯题,可以倒着想,因为每个人都不可能一次拿走4个石子,所以如果剩下4个石子,谁先拿谁输。所以如果想自己赢,就需要在倒数第3局的时候,自己拿走石子后保证剩下4个石子,这样小伙伴不管拿1,2或3个石子,都能保证自己拿走最后一个石子。同理,要想自己最终赢得胜利,只需要保证倒数2n+1局的时候,自己拿走石子后保证剩下的石子数为4的倍数。因为自己第一个拿,所以只有石子总数不是4的倍数,这样自己拿走除以4后余数个石子,才能保证剩下的石子数是4的倍数,取得游戏的胜利。综上:若石子数是4的倍数,则输;否则,赢。

Code:

class Solution {
public:
bool canWinNim(int n) {
if (n%4!=0) return true;
else return false;
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: